package org.processmining.streaminductiveminer.algorithms.stream.readers;

import org.processmining.eventstream.readers.processtree.ProcessTreeXSReaderResultVisualizer;
import org.processmining.eventstream.readers.processtree.XSEventStreamToProcessTreeReader;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.InductiveMiner.dfgOnly.Dfg;
import org.processmining.plugins.InductiveMiner.dfgOnly.DfgMiningParameters;
import org.processmining.plugins.InductiveMiner.dfgOnly.plugins.IMdProcessTree;
import org.processmining.processtree.ProcessTree;
import org.processmining.stream.core.enums.CommunicationType;
import org.processmining.stream.reader.views.XSReaderSequenceOfResultsView;
import org.processmining.streaminductiveminer.algorithms.stream.readers.abstr.AbstractStreamInductiveMiner;
import org.processmining.streaminductiveminer.parameters.StreamInductiveMinerParameters;

public class StreamInductiveMinerPTXSEventReaderImpl extends AbstractStreamInductiveMiner<ProcessTree>
		implements XSEventStreamToProcessTreeReader {

	public StreamInductiveMinerPTXSEventReaderImpl(final PluginContext context,
			final CommunicationType communicationType, final StreamInductiveMinerParameters params) {
		super("Stream Inductive Miner (Process Tree, CxA: " + params.getCaseAdministrationDataStructureType().getName() + "-"
				+ params.getCaseAdministrationDataStructureParameters().toString() + "; AxA: "
				+ params.getInternalRepresentationDataStructureType().getName() + "-"
				+ params.getInternalRepresentationDataStructureParameters().toString() + ")",
				new XSReaderSequenceOfResultsView<>("Visualizer of: Stream Inductive Miner (Process Tree)", null,
						params.getRefreshRate(), ProcessTreeXSReaderResultVisualizer.instance(context)),
				communicationType, params);
		((XSReaderSequenceOfResultsView<ProcessTree>) getVisualization()).setReader(this);

	}

	protected ProcessTree discover(Dfg dfg, DfgMiningParameters dfgParams) {
		return IMdProcessTree.mineProcessTree(dfg, dfgParams);
	}
}
